%Developed By Taha Mansouri
%Size of input data
[Row, Col]=size(P);
%Number of clusters
K=4;
%initialize K clusters
for i=1:Row
    P(i,Col)=randi(K,1,1);
end
%Traping of initializaion
KMInput=P;
NKAInput=P;
KohonenInput=P;
TSInput=P;
GAInput=P;
%Parameter initialization
T=1000;%Maxinmum number of iterations
Error=.10;%Accepted error
KmeansGoal=1000;%K-Means Result
TSGoal=1000;%Tabu Search Result
NKAGoal=1000;%NKA Result
GAGoal=1000;%GA Result
SOMGOAL=1000;%SOM Result
co=0;%Probablity of NKA mutation
TS=zeros(T,1);%Tabu search's response vector
KMF=zeros(T,1);%K-Means's response vector
NKAF=zeros(T,1);%NKA's response vector
SOM=zeros(T,1);%SOM's response vector
GAF=zeros(T,1);%GA's response vector
%tabu Initialization
N=4; %number of neighbours
er=.1;
tt=5;
Memory=[];

%Start k-means
[A1,C1] = Gravot(KMInput,K);
t=1;
e=1000;
clc
tic;
while(e>Error)
    for i=1:Row
        for j=1:K
            M=power(A1(j,:)-KMInput(i,:),2);
            M(1,Col)=0;
            S(j)=sum(M(:,:));
        end
        [L(i), KMInput(i,Col)]=min(S);
    end
    %total sumention of inetrnal distance
    U= sum(L(:));
    %total sumention of external distance
    a=Fing(A1);
    %Performance index of k-means
    KMF(t)=U/a;
    if KMF(t) < KmeansGoal
        KmeansGoal=KMF(t);
        KMResponse=KMInput(:,Col);
        timeKmeans=toc;
        b=t;
    end
    [A1,C1] = Gravot(KMInput,K);
    e=KMF(t);
    t=t+1;
    if t>10
        break
    end
end

%Start NKA
thk=1;
e=1000;
[A2,C2] = Gravot(NKAInput,K);
tic;
while(e>Error)
    for i=1:Row
        for j=1:K
            M=power(A2(j,:)-NKAInput(i,:),2);
            M(1,Col)=0;
            S(j)=sum(M(:,:));
        end
        [L(i),NKAInput(i,Col)]=min(S);
    end
    V= sum(L(:));
    a=Fing(A2);
    %Performance Index of NKA
    NKAF(thk)=V/a;
    if NKAF(thk) < NKAGoal
        co=1;
        timeNKA=toc;
        NKAGoal=NKAF(thk);
    else
        co=co+1;
    end
    %mutation
    if thk> 4
        kapa= (NKAF(thk)-NKAF(thk-1))/thk;
        p = 1 /(1 + exp(kapa));
        r=rand();
        if r<=p
            A2 = Gmutat(A2,thk,co);
        else
            [A2,C2] = Gravot(NKAInput,K);
        end
    else
        [A2,C2] = Gravot(NKAInput,K);
    end
    e=NKAF(thk);
    thk=thk+1;
    if thk>T
        timeNKA=toc;
        break;
    end
end

%Start Tabu Search
%Size of input data
[SS,C] = LinearGravot(TSInput,K);
[alfa, beta]=size(SS);
Best=SS;
counter=1;
[Best(1,beta) , Response]=fitnessFunction(SS,TSInput);
if Best(1,beta) < TSGoal
        TSGoal=Best(1,beta);
        TS(counter)=TSGoal;
end
e=1000;
tic; 
while(e>Error)
    A=GeneratNeighbours(SS,N,Memory,er,counter);
    [s1 s2]=size(A);
    for t=1:s1
        [A(t,s2), tempR(:,t)] =fitnessFunction(A(t,:),TSInput);
    end
    [A , idx]=LinearSot(A);
    SS=A(1,:);
    Memory=Update(Memory,A,tt,Best);
    if SS(1,beta)< Best(1,beta)
        timeTS=toc;
        Best=SS;
        TSGoal=Best(1,beta);
        Response=tempR(:,idx(1));
    end
    TS(counter)=Best(1,beta);
    %Performance Index of tabu search
    e=TS(counter);
    counter=counter+1;
    if counter>T
        break;
    end
    
end
%Start genetic algorithms
%number of polpulation
pop=100;
GA=randi(K,pop , Row+1);
GACounter=1;
Elite=10;
e=1000;
pmut=.4;
gacounter=1;
tic;
while(e>Error)
    if gacounter>T
        timeGA=toc;
        break
    end
    for t=1:pop
       GA(t,Row+1)= GAravit(GA(t,:),GAInput,K);
    end
     GA=LinearSot(GA);
     if GA(1,Row+1)<GAGoal
         timeGA=toc;
         GAGoal=GA(1,Row+1);
     end
    %Selection of offspring
   [Child1, Child2]=select(GA, Elite);
    %Crossover
    GA=crossov(Child1, Child2);
    for t=1:pop
        GA(t,Row+1)= GAravit(GA(t,:),GAInput,K);
    end
    GA=LinearSot(GA);
if GA(1,Row+1)<GAGoal
         timeGA=toc;
         GAGoal=GA(1,Row+1);
     end
    for i=1:pop
        r=rand();
        if r<=pmut
            GA(i,:)=mutat(GA(i,:),K);
        end
    end
    e=GAGoal;
    %Performance Index of Genetic Algorithm
    GAF(gacounter)=e;
    gacounter=gacounter+1;
end

%Kohonen Initialization
eta=.69;
R=2;
n=round(K^.5);
m=round(K^.5);
[Z,CA] = Gravot(KohonenInput,K);
W=Z(:,1:Col-1);
e=1000;
%start kohonen
t=1000;
som=1;
delta=eta/T;
tic;
while(e>Error)
    for i=1:Row
        %number of records
        %Competition
        for j=1:K
            %number of neurones
            M=power(KohonenInput(i,1:Col-1)-W(j,:),2);
            S(j)=sum(M(:,:))^.5;
        end
        [l, v(i)]=min(S);
        %cooperation
        if R > 0
            for counter=R:1
                if v(i)>counter
                    W(v(i)-counter,:)=W(v(i)-counter,:)+ (eta * (KohonenInput(i,1:Col-1) -W(v(i)-counter,:)));
                end
                if v(i)> counter* n
                    W(v(i)-counter*n,:)=W(v(i)-counter*n,:)+ (eta * (KohonenInput(i,1:Col-1) -W(v(i)-counter*n,:)));
                end
                if v(i) + counter < K
                    W(v(i)+counter,:)=W(v(i)+counter,:)+ (eta * (KohonenInput(i,1:Col-1) -W(v(i)+counter,:)));
                end
                if v(i) + counter * n < K
                    W(v(i)+counter*n,:)=W(v(i)+counter*n,:)+ (eta * (KohonenInput(i,1:Col-1) -W(v(i)+counter*n,:)));
                end
            end
        end
        
        %adaption
        W(v(i),:)=W(v(i),:)+ (eta * (KohonenInput(i,1:Col-1) -W(v(i),:)));
        %assignment
        KohonenInput(i,Col)=v(i);
    end
    eta=eta-delta;
    for i=1:Row
        for j=1:K
            M=power(KohonenInput(i,1:Col-1)-W(j,:),2);
            S(j)=sum(M(:,:));
        end
        [L(i),KohonenInput(i,Col)]=min(S);
    end
    V= sum(L(:));
    a=Fing(Z);
    %Performance Index of SOM
    SOM(som)=V/a;
    e=SOM(som);
    som=som+1;
    if som>T
        break;
    end
end
SOMGOAL=e;
timeSOM=toc;



timeKmeans
timeNKA
timeTS
timeGA
timeSOM

KmeansGoal
TSGoal
NKAGoal
GAGoal
SOMGOAL

